#coding=utf-8
import os
import datetime
import pandas as pd
from LIB.BACKEND import DBManager, Log
from LIB.MIDDLE import SignalMonitor
from sqlalchemy import create_engine
from sqlalchemy.orm import sessionmaker
import time, datetime
import traceback
from LIB.MIDDLE.DeltSoc import LFPDeltSoc20210804 as LFPDeltSoc
from urllib import parse

dbManager = DBManager.DBManager()
if __name__ == "__main__":
    # 数据库配置
    host = 'rm-bp10j10qy42bzy0q77o.mysql.rds.aliyuncs.com'
    port = 3306
    user = 'qx_cas'
    password = parse.quote_plus('Qx@123456')
    database = 'qx_cas'

    db_engine = create_engine(
        "mysql+pymysql://{}:{}@{}:{}/{}?charset=utf8".format(
            user, password, host, port, database
        ))
    DbSession = sessionmaker(bind=db_engine)
    
    
    # 日志配置
    now_str = time.strftime("%Y-%m-%d %H:%M:%S", time.localtime())[0:10]
    if not os.path.exists('log/' + now_str):
        os.makedirs('log/' + now_str)
    log = Log.Mylog(log_name='delta_soc', log_level = 'info')
    log.set_file_hl(file_name='log/{}/info.log'.format(now_str), log_level='info', size=1024* 1024 * 100)
    log.set_file_hl(file_name='log/{}/error.log'.format(now_str), log_level='error', size=1024* 1024 * 100)
    logger = log.get_logger()

    logger.info("pid is {}".format(os.getpid()))
    logger.error("pid is {}".format(os.getpid()))
    
    SNdata_6060 = pd.read_excel('骑享资产梳理-20210621.xlsx', sheet_name='6060')
    SNnums_6060=SNdata_6060['SN号']
    now_time=datetime.datetime.now().strftime('%Y-%m-%d %H:%M:%S')
    now_time = "2021-08-01 00:00:00" # 定时任务开启时，需要删除改行！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！

    now_time=datetime.datetime.strptime(now_time,'%Y-%m-%d %H:%M:%S')
    start_time=now_time-datetime.timedelta(days=1000)
    end_time=str(now_time)
    start_time=str(start_time)

    for sn in SNnums_6060.tolist():
        try:
            res = LFPDeltSoc.cal_deltsoc(sn, end_time, start_time)
            if not res.empty:
                res.columns = ['time', 'sn', 'delta_soc']
                res.to_sql("consistency_delta_soc",con=db_engine, if_exists="append",index=False)
            logger.info("6040 SN: {} DONE!".format(sn))
        except:
            logger.error(traceback.format_exc)
            logger.error(u"{} ：{},{} 任务运行错误\n".format(sn,start_time,end_time), exc_info=True)


